create or replace PROCEDURE EXPORTA_FOTO_PRATO
(P_PRATOS IN VARCHAR2,
 P_ORIGEM IN VARCHAR2,
 P_CDFILIAL IN VARCHAR2,
 P_CDSERVFILI IN VARCHAR2, 
 P_DESTINO IN VARCHAR2,
 P_FILIAIS IN VARCHAR2,
 P_SERVICOS IN VARCHAR2,
 P_SOBREPOR IN VARCHAR)
AS
    V_INDICE NUMBER;
    V_CDFILAUXPRAT VARCHAR2(4);
    V_CDPRATO VARCHAR2(10);
    V_CDFILIALDEST VARCHAR2(4);
    V_CDSERVFILIDEST VARCHAR2(5);
    V_EXISTE_FOTO_DEST NUMBER;
    V_EXISTE_FOTO_ORIGEM VARCHAR2(1);
    V_FGFOTOPRATOURL VARCHAR2(2000);
    V_FGFOTOPRATOURL_APP VARCHAR2(2000);
    V_NRFOTOPRATOBLOB_DEST NUMBER;
    V_FGFOTOPRATOURL_DEST VARCHAR2(2000);
    V_FGFOTOPRATOURL_APP_DEST VARCHAR2(2000);
    
BEGIN
    -- Origem e destino padrao, nao realiza a operacao
    IF P_ORIGEM = 'P' AND P_DESTINO = 'P' THEN 
        RETURN;
    END IF;
    FOR C_LISTAPRATOS IN 
    (SELECT CDLISTA
       FROM LISTA L
      WHERE L.NRLISTA = P_PRATOS) LOOP
        -- Separa os valores da chave do prato para melhor uso
        V_CDFILAUXPRAT := NULL;
        V_CDPRATO := NULL;
        V_INDICE := INSTR(C_LISTAPRATOS.CDLISTA, '-', 1);
        IF(V_INDICE > 0) THEN
            V_CDFILAUXPRAT := SUBSTR(C_LISTAPRATOS.CDLISTA, 1, V_INDICE-1);
            V_CDPRATO := SUBSTR(C_LISTAPRATOS.CDLISTA, V_INDICE+1, 10);
        END IF;
        -- Verifica se a foto de origem existe        
        IF P_ORIGEM = 'P' THEN
            BEGIN
                SELECT FGFOTOPRATOURL, FGFOTOPRATOURL_APP
                  INTO V_FGFOTOPRATOURL, V_FGFOTOPRATOURL_APP
                  FROM FOTOPRATOBLOB
                 WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                   AND CDPRATO = V_CDPRATO
                   AND IDRECEITA = 'P';
            EXCEPTION
                WHEN OTHERS THEN
                    V_FGFOTOPRATOURL := NULL;
                    V_FGFOTOPRATOURL_APP := NULL;
            END;
        ELSIF P_ORIGEM = 'L' THEN
            BEGIN
                SELECT FGFOTOPRATOURL, FGFOTOPRATOURL_APP
                  INTO V_FGFOTOPRATOURL, V_FGFOTOPRATOURL_APP
                  FROM FOTOPRATOBLOB
                 WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                   AND CDPRATO = V_CDPRATO
                   AND CDFILIAL = P_CDFILIAL
                   AND IDRECEITA = 'F';
            EXCEPTION
                WHEN OTHERS THEN
                    V_FGFOTOPRATOURL := NULL;
                    V_FGFOTOPRATOURL_APP := NULL;
            END;
        ELSIF P_ORIGEM = 'S' THEN
            BEGIN
                SELECT FGFOTOPRATOURL, FGFOTOPRATOURL_APP
                  INTO V_FGFOTOPRATOURL, V_FGFOTOPRATOURL_APP
                  FROM FOTOPRATOBLOB
                 WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                   AND CDPRATO = V_CDPRATO
                   AND CDFILIAL = P_CDFILIAL
                   AND CDSERVFILI = P_CDSERVFILI
                   AND IDRECEITA = 'S';
            EXCEPTION
                WHEN OTHERS THEN
                    V_FGFOTOPRATOURL := NULL;
                    V_FGFOTOPRATOURL_APP := NULL;
            END;        
        END IF;

        V_EXISTE_FOTO_ORIGEM := 'N';
        -- verifica se existe a foto de origem, tendo url ou url para foto do app
        IF  V_FGFOTOPRATOURL IS NOT NULL OR V_FGFOTOPRATOURL_APP IS NOT NULL THEN
            V_EXISTE_FOTO_ORIGEM := 'S';
        END IF;

        -- Se a foto de origem existir
        IF V_EXISTE_FOTO_ORIGEM = 'S' THEN
            -- PADRAO
            IF P_DESTINO = 'P' THEN
                -- Se sobrepoe, apaga o que ja esta no destino, se nao apenas altera se nao tiver no destino
                IF P_SOBREPOR = 'S' THEN                
                    DELETE FROM FOTOPRATOBLOB
                    WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                      AND CDPRATO = V_CDPRATO
                      AND IDRECEITA = 'P';
                    V_EXISTE_FOTO_DEST := 0;
                ELSE
                   BEGIN
                      SELECT NRFOTOPRATOBLOB, FGFOTOPRATOURL, FGFOTOPRATOURL_APP
                        INTO V_NRFOTOPRATOBLOB_DEST, V_FGFOTOPRATOURL_DEST, V_FGFOTOPRATOURL_APP_DEST
                        FROM FOTOPRATOBLOB
                       WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                         AND CDPRATO = V_CDPRATO
                         AND IDRECEITA = 'P';
                   EXCEPTION
                      WHEN OTHERS THEN
                         V_NRFOTOPRATOBLOB_DEST := 0;
                   END;                      
                   V_EXISTE_FOTO_DEST := NVL(V_NRFOTOPRATOBLOB_DEST,0);
                END IF;

                -- Se o destino estiver vazio
                IF V_EXISTE_FOTO_DEST = 0 THEN  

                    -- Insere foto da origem no destino
                    INSERT INTO FOTOPRATOBLOB(NRFOTOPRATOBLOB, CDFILAUXPRAT, CDPRATO, IDRECEITA, CDFILIAL, CDSERVFILI, FGFOTOPRATO, NRFOTO, IDATIVO, DTINCLUSAO, DTULTATU, FGFOTOPRATOURL, FGFOTOPRATOURL_APP)
                       VALUES(RETORNA_NOVO_CODIGO('FOTOPRATOBLOB',1),V_CDFILAUXPRAT,V_CDPRATO,'P',NULL,NULL,NULL,'01','S',SYSDATE, SYSDATE,V_FGFOTOPRATOURL, V_FGFOTOPRATOURL_APP);

                -- existe registro de foto no destino porem nenhuma url (conversao da foto para o fileserver) no destino, por isso sera atualizado somente as urls das fotos
                ELSIF V_FGFOTOPRATOURL_DEST IS NULL OR V_FGFOTOPRATOURL_APP_DEST IS NULL THEN
                    UPDATE FOTOPRATOBLOB
                       SET FGFOTOPRATOURL = NVL(FGFOTOPRATOURL, V_FGFOTOPRATOURL),
                           FGFOTOPRATOURL_APP = NVL(FGFOTOPRATOURL_APP, V_FGFOTOPRATOURL_APP)
                    WHERE NRFOTOPRATOBLOB = V_NRFOTOPRATOBLOB_DEST;
                END IF;  

            -- LOCAL
            ELSIF P_DESTINO = 'L' THEN
                FOR C_FILIAIS IN
                (SELECT CDLISTA AS CDFILIAL
                   FROM LISTA L
                  WHERE L.NRLISTA = P_FILIAIS) LOOP
                    -- Se origem igual ao destino, passa para a proxima unidade
                    IF P_ORIGEM = 'L' AND C_FILIAIS.CDFILIAL = P_CDFILIAL THEN
                        CONTINUE;
                    END IF;
                    IF P_SOBREPOR = 'S' THEN                
                       DELETE FROM FOTOPRATOBLOB
                        WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                          AND CDPRATO = V_CDPRATO
                          AND CDFILIAL = C_FILIAIS.CDFILIAL
                          AND IDRECEITA = 'F';
                       V_EXISTE_FOTO_DEST := 0;
                    ELSE
                       BEGIN
                          SELECT NRFOTOPRATOBLOB, FGFOTOPRATOURL, FGFOTOPRATOURL_APP
                            INTO V_NRFOTOPRATOBLOB_DEST, V_FGFOTOPRATOURL_DEST, V_FGFOTOPRATOURL_APP_DEST
                            FROM FOTOPRATOBLOB
                           WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                             AND CDPRATO = V_CDPRATO
                             AND CDFILIAL = C_FILIAIS.CDFILIAL
                             AND IDRECEITA = 'F';                    
                       EXCEPTION
                          WHEN OTHERS THEN
                             V_NRFOTOPRATOBLOB_DEST := 0;
                       END;
                       V_EXISTE_FOTO_DEST := NVL(V_NRFOTOPRATOBLOB_DEST,0);
                    END IF;
                    -- Se o destino estiver vazio
                    IF V_EXISTE_FOTO_DEST = 0 THEN  
                       -- Insere foto da origem no destino
                       INSERT INTO FOTOPRATOBLOB(NRFOTOPRATOBLOB, CDFILAUXPRAT, CDPRATO, IDRECEITA, CDFILIAL, CDSERVFILI, FGFOTOPRATO, NRFOTO, IDATIVO, DTINCLUSAO, DTULTATU, FGFOTOPRATOURL, FGFOTOPRATOURL_APP)
                          VALUES(RETORNA_NOVO_CODIGO('FOTOPRATOBLOB',1),V_CDFILAUXPRAT,V_CDPRATO,'F',C_FILIAIS.CDFILIAL,NULL,NULL,'01','S',SYSDATE, SYSDATE,V_FGFOTOPRATOURL, V_FGFOTOPRATOURL_APP);
                    -- existe registro de foto no destino porem nenhuma url (conversao da foto para o fileserver) no destino, por isso sera atualizado somente as urls das fotos
                    ELSIF V_FGFOTOPRATOURL_DEST IS NULL OR V_FGFOTOPRATOURL_APP_DEST IS NULL THEN
                       UPDATE FOTOPRATOBLOB
                          SET FGFOTOPRATOURL = NVL(FGFOTOPRATOURL, V_FGFOTOPRATOURL),
                              FGFOTOPRATOURL_APP = NVL(FGFOTOPRATOURL_APP, V_FGFOTOPRATOURL_APP)
                        WHERE NRFOTOPRATOBLOB = V_NRFOTOPRATOBLOB_DEST;      
                    END IF;
                END LOOP;
                
            -- SERVICO
            ELSIF P_DESTINO = 'S' THEN
                FOR C_SERVICOS IN
                (SELECT CDLISTA
                   FROM LISTA L
                  WHERE L.NRLISTA = P_SERVICOS) LOOP
                    -- Separa a chave do servico em filial e codigo do serviço
                    V_CDFILIALDEST := NULL;
                    V_CDSERVFILIDEST := NULL;
                    V_INDICE := INSTR(C_SERVICOS.CDLISTA, '_', 1);
                    IF(V_INDICE > 0) THEN
                        V_CDFILIALDEST := SUBSTR(C_SERVICOS.CDLISTA, 1, V_INDICE-1);
                        V_CDSERVFILIDEST := SUBSTR(C_SERVICOS.CDLISTA, V_INDICE+1, 5);
                    END IF;
                    -- Se o valor na lista nao pode ser separado em filial e servico
                    IF V_CDFILIALDEST IS NULL THEN
                        CONTINUE;
                    END IF;
                    -- Se origem igual ao destino, passa para o proximo servico
                    IF P_ORIGEM = 'S' AND V_CDFILIALDEST = P_CDFILIAL AND V_CDSERVFILIDEST = P_CDSERVFILI THEN
                        CONTINUE;
                    END IF;
                    
                    IF P_SOBREPOR = 'S' THEN
                       DELETE FROM FOTOPRATOBLOB
                        WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                          AND CDPRATO = V_CDPRATO
                          AND CDFILIAL = V_CDFILIALDEST
                          AND CDSERVFILI = V_CDSERVFILIDEST
                          AND IDRECEITA = 'S';
                        V_EXISTE_FOTO_DEST := 0;
                    ELSE
                       BEGIN
                          SELECT NRFOTOPRATOBLOB, FGFOTOPRATOURL, FGFOTOPRATOURL_APP
                            INTO V_NRFOTOPRATOBLOB_DEST, V_FGFOTOPRATOURL_DEST, V_FGFOTOPRATOURL_APP_DEST
                            FROM FOTOPRATOBLOB
                           WHERE CDFILAUXPRAT = V_CDFILAUXPRAT
                             AND CDPRATO = V_CDPRATO
                             AND CDFILIAL = V_CDFILIALDEST
                             AND CDSERVFILI = V_CDSERVFILIDEST
                             AND IDRECEITA = 'S';
                       EXCEPTION
                          WHEN OTHERS THEN
                             V_NRFOTOPRATOBLOB_DEST := 0;
                       END;
                       V_EXISTE_FOTO_DEST := NVL(V_NRFOTOPRATOBLOB_DEST,0);
                    END IF;
                    -- Se o destino estiver vazio
                    IF V_EXISTE_FOTO_DEST = 0 THEN  
                       -- Insere foto da origem no destino
                       INSERT INTO FOTOPRATOBLOB(NRFOTOPRATOBLOB, CDFILAUXPRAT, CDPRATO, IDRECEITA, CDFILIAL, CDSERVFILI, FGFOTOPRATO, NRFOTO, IDATIVO, DTINCLUSAO, DTULTATU, FGFOTOPRATOURL, FGFOTOPRATOURL_APP)
                          VALUES(RETORNA_NOVO_CODIGO('FOTOPRATOBLOB',1), V_CDFILAUXPRAT, V_CDPRATO, 'S', V_CDFILIALDEST, V_CDSERVFILIDEST, NULL, '01', 'S', SYSDATE, SYSDATE, V_FGFOTOPRATOURL, V_FGFOTOPRATOURL_APP);
                    -- existe registro de foto no destino porem nenhuma url (conversao da foto para o fileserver) no destino, por isso sera atualizado somente as urls das fotos
                    ELSIF V_FGFOTOPRATOURL_DEST IS NULL OR V_FGFOTOPRATOURL_APP_DEST IS NULL THEN
                       UPDATE FOTOPRATOBLOB
                          SET FGFOTOPRATOURL = NVL(FGFOTOPRATOURL, V_FGFOTOPRATOURL),
                              FGFOTOPRATOURL_APP = NVL(FGFOTOPRATOURL_APP, V_FGFOTOPRATOURL_APP)
                        WHERE NRFOTOPRATOBLOB = V_NRFOTOPRATOBLOB_DEST;      
                    END IF;
                END LOOP;
            END IF;            
        END IF;
    END LOOP;
END;
