/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GERENTE                                                  */
/* Tabela : GERENTE                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GERENTE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GERENTE
GO

CREATE TRIGGER DTULTATU_GERENTE
ON GERENTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GERENTE', null, 'CDOPERADOR=' + CDOPERADOR+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GERENTE
      SET DTULTATUGERE = GETDATE()
      FROM INSERTED;
   END;
END;
GO
