<?php
namespace Teknisa\Model\Gestaopessoas\Entities;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpaeventohEntity;
use HCM\Util\FPA;

class FpaEventom extends \Teknisa\Model\Gestaopessoas\Entities\Base\FpaEventom {
    
    public static function compatibilizaReferenciaHoras($referencia, $tipo_ref, $jornada_diaria){

        switch($tipo_ref){
        case FpaeventohEntity::IDUNIDREFEREVEN_HORA:
            return $referencia;
            break;
        case FpaeventohEntity::IDUNIDREFEREVEN_DIA:
            return $referencia * $jornada_diaria;
            break;
        case FpaeventohEntity::IDUNIDREFEREVEN_HORA_MINUTO:
            return FPA::converteHoraDecimal($referencia);
            break;
        default:
            $msg = 'Verifique o tipo de referencia: '.$tipo_ref;
            $msg .= ' Referencia:'.$referencia.' - '.get_called_class().'<br/>';
            MsgCalculo::getInstance()->adicionaMensagem($msg);
        }

    }

    public function compatibilizaReferenciaDiasParaN($dias, $jornada_diaria){
        switch($this->historico->getIdunidrefereven()){
        case FpaeventohEntity::IDUNIDREFEREVEN_DIA:
            return $dias;
            break;
        case FpaeventohEntity::IDUNIDREFEREVEN_HORA:
            $referencia = $dias * $jornada_diaria;
            if ($referencia > 219.9 && $referencia < 220.01){
                $referencia = 220.0;
            } else if ($referencia > 109.9 && $referencia < 110.01){
                $referencia = 110.0;
            }
            return $referencia;
            break;
        default:
            $msg = 'Verifique o tipo de referencia: '.$tipo_ref;
            $msg .= ' Referencia:'.$referencia.' - '.get_called_class().'<br/>';
            MsgCalculo::getInstance()->adicionaMensagem($msg);
        }

    }

    public static function compatibilizaReferenciaDias($referencia, $tipo_ref, $jornada_diaria){
        switch($tipo_ref){
        case FpaeventohEntity::IDUNIDREFEREVEN_HORA:
            return $referencia / $jornada_diaria;
            break;
        case FpaeventohEntity::IDUNIDREFEREVEN_DIA:
            return $referencia;
            break;
        case FpaeventohEntity::IDUNIDREFEREVEN_HORA_MINUTO:
            $referenciaAux = FPA::converteHoraDecimal($referencia);
            return $referenciaAux / $jornada_diaria;
            break;
        default:
            $msg = 'Verifique o tipo de referencia: '.$tipo_ref;
            $msg .= ' Referencia:'.$referencia.' - '.get_called_class().'<br/>';
            MsgCalculo::getInstance()->adicionaMensagem($msg);
        }
    }

    public function determinaDataOcorrencia(){

        $tipoData = $this->historico->getIddtocorrencia();
        switch ($tipoData) {
        case FpaeventohEntity::IDDTOCORRENCIA_COMPETENCIA:
            return $this->_mesCompetencia;
        case FpaeventohEntity::IDDTOCORRENCIA_PAGAMENTO:
            return $this->_dtPagamento;
        }
    }
    
    public function getOrdemTipoEvento($ordem) {
        $this->_tipoEvento = array(
                              FpaeventomEntity::IDTIPOEVENTO_PROVENTO => '1',
                              FpaeventomEntity::IDTIPOEVENTO_DESCONTO => '2',
                              FpaeventomEntity::IDTIPOEVENTO_ENCARGO  => '3',
                              FpaeventomEntity::IDTIPOEVENTO_TOTAL    => '4',
                             );
        return $this->_tipoEvento[$ordem];
    }
}